// Nina Prakash
// 60-223 Intro to Phys Comp
// Final Project - motor control

// DC Motor Code (iteration 1)

//for up/down motion
const int enablePin = 11;
const int A1Pin = 10;
const int A2Pin = 9;
const int switchPin = 2;

//for open/close motion
const int servoPin = 3;
int duration = 0;
int distance = 0;
const int trigPin = 6;
const int echoPin = 5;

#include <Servo.h>
Servo myservo;
int pos = 0;

void setup() {
  //for open/close motion
  myservo.attach(servoPin);
  pinMode(trigPin, OUTPUT);
  pinMode(echoPin, INPUT);

  //for up/down motion
  pinMode(enablePin, OUTPUT);
  pinMode(A1Pin, OUTPUT);
  pinMode(A2Pin, OUTPUT);
  pinMode(A0, INPUT);
  Serial.begin(115200);
}

void loop() {

  digitalWrite(trigPin, LOW);
  delayMicroseconds(2);

  digitalWrite(trigPin, HIGH);
  delayMicroseconds(10);
  digitalWrite(trigPin, LOW);

  duration = pulseIn(echoPin, HIGH);
  distance = duration*0.034/2;
  Serial.print("Distance: ");
  Serial.println(distance);

  // when get close, open
  if (distance < 60) {
    Serial.println("hello I'm close");
    pos = 90;
    myservo.write(pos);
  }

  //when further away, close
  else {
    Serial.println("far");
    pos = 10;
    myservo.write(pos);
  }
  delay(500);

  //go up or down
  if (digitalRead(switchPin) == LOW) {
    //Serial.println("going up");
    digitalWrite(enablePin, HIGH);
    digitalWrite(A1Pin, HIGH);
    digitalWrite(A2Pin, LOW);
  }
  else {
    digitalWrite(enablePin, HIGH);
    //Serial.println("going down");
    digitalWrite(A1Pin, LOW);
    digitalWrite(A2Pin, HIGH);
  }
}

